//=============================================================================
// Version 2

#include <iostream>
#include "computerfff.hpp"
#include "computerlff.hpp"
#include "human.hpp"
#include "tictactoe.hpp"
using namespace std;

//-----------------------------------------------------------------------------

bool play(Player& pl, TicTacToe& ttt)
{
   // 1. Spieler nach seinem Zug fragen
   Move m = pl.askForMove(ttt);

   // 2. Ausgabe Zug
   cout << "\n" << pl.getName() << " macht Zug : " << m << "\n\n";

   // 3. Zug wird gesetzt
   ttt.set(m);

   // 4. Spiel ausgeben
   cout << ttt << '\n';

   // 5. berprfen, ob Spieler gewonnen hat: ja => Spielende mit Meldung
   if (ttt.hasWin(m.getGameColor()))
   {
      cout << "Gratulation - " << pl.getName() << " hat gewonnen - juhuuu...\n";
      return true;
   }

   // 6. berprfen, ob das Spiel am Ende ist: ja => remis => Spielende mit Meldung
   if (ttt.isFull())
   {
      cout << "Spiel ist Remis ausgegangen...\n";
      return true;
   }

   return false;
}

//-----------------------------------------------------------------------------

int main()
{
   cout << "WS 2024/25 Tic-Tac-Toe 2\n\n";

   // 0. Player erzeugen
   Human human1(GameColor::white);
   Human human2(GameColor::black);
   ComputerFFF computerfff1(GameColor::white);
   ComputerFFF computerfff2(GameColor::black);
   ComputerLFF computerlff1(GameColor::white);
   ComputerLFF computerlff2(GameColor::black);
   Player& pl1 = computerfff1;
   Player& pl2 = computerlff2;

   // 1. Spiel erzeugen
   TicTacToe ttt;
   
   // 2. Spiel ausgeben
   cout << ttt << '\n';

   for (;;)
   {
      if (play(pl1, ttt)) break;
      if (play(pl2, ttt)) break;
   }
}
