#ifndef PLAYER_HPP
#define PLAYER_HPP

#include "move.hpp"
#include "tictactoe.hpp"
#include <string>

class Player
{
public:
   Player(GameColor gc) : mGameColor{ gc } {}

   virtual ~Player() = default;

   virtual Move askForMove(const TicTacToe&) = 0;

   virtual std::string getName() const = 0;

   GameColor getGameColor() const { return mGameColor; }

private:
   GameColor mGameColor;
};

#endif
